﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Spread_HandleKeyDown
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            //*********** For handling functional keys in key down
            FarPoint.Win.Spread.InputMap im;
            FarPoint.Win.Spread.Keystroke keyF2 = new FarPoint.Win.Spread.Keystroke(Keys.F2, Keys.None, false);
            im = fpSpread1.GetInputMap(FarPoint.Win.Spread.InputMapMode.WhenAncestorOfFocused);
            im.Put(keyF2, FarPoint.Win.Spread.SpreadActions.None);

            FarPoint.Win.Spread.InputMap im1;
            FarPoint.Win.Spread.Keystroke keyF3 = new FarPoint.Win.Spread.Keystroke(Keys.F3, Keys.None, false);
            im1 = fpSpread1.GetInputMap(FarPoint.Win.Spread.InputMapMode.WhenAncestorOfFocused);
            im1.Put(keyF3, FarPoint.Win.Spread.SpreadActions.None);

            FarPoint.Win.Spread.InputMap im2;
            FarPoint.Win.Spread.Keystroke keyF4 = new FarPoint.Win.Spread.Keystroke(Keys.F4, Keys.None, false);
            im2 = fpSpread1.GetInputMap(FarPoint.Win.Spread.InputMapMode.WhenAncestorOfFocused);
            im2.Put(keyF4, FarPoint.Win.Spread.SpreadActions.None);

            fpSpread1.KeyDown += new KeyEventHandler(fpSpread1_KeyDown);
            fpSpread1.EditModeOn += new EventHandler(fpSpread1_EditModeOn);
            fpSpread1.EditModeOff += new EventHandler(fpSpread1_EditModeOff);
        }
        void fpSpread1_EditModeOn(object sender, EventArgs e)
        {
            System.Windows.Forms.KeyEventHandler KeyDownHandler = fpSpread1_KeyDown;
            fpSpread1.EditingControl.KeyDown += KeyDownHandler;
        }
        void fpSpread1_EditModeOff(object sender, EventArgs e)
        {
            System.Windows.Forms.KeyEventHandler KeyDownHandler = fpSpread1_KeyDown;
            fpSpread1.EditingControl.KeyDown -= KeyDownHandler;
        }
        void fpSpread1_KeyDown(object sender, KeyEventArgs e)
        {
            Console.WriteLine(e.KeyCode + ": key pressed");
        }
      
    }
}
